﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
//using System.Windows.Shapes;
using System.Windows.Threading;
using Steema.TeeChart.WPF;
using Steema.TeeChart.WPF.Drawing;
using Steema.TeeChart.WPF.Styles;
using Steema.TeeChart.WPF.Tools;

namespace WpfScroll
{
    /// <summary>
    /// Interaction logic for WindowScroll.xaml
    /// </summary>
    public partial class WindowScroll : Window
    {
        List<TrendData> Points = new List<TrendData>();
        double totalMins = 60;
        double ScrollYearMins = 1440 * 1;
        double HISTORYREADHOURS = 2160;
        private DateTime TrendWidgetStartTime;

        Line line1 = new Line();
        //FastLine line = new FastLine();
        Line line = new Line();
        Random rnd = new Random();
        CursorTool pastCursorTool;
        CursorTool currentCursorTool;
        DispatcherTimer timer;
        DateTime ViewStartTime;
        DateTime ViewEndTime;
        private DateTime TrendWidgetEndTime;
        int data = 70;

        public WindowScroll()
        {
            InitializeComponent();
            IntializeChart();
            this.SizeChanged += Window23_SizeChanged;
            tChart1.GetAxisLabel += tChart1_GetAxisLabel;
        }


        void tChart1_GetAxisLabel(object sender, GetAxisLabelEventArgs e)
        {
            if (sender == tChart1.Axes.Left)
            {
                ((Axis)sender).Labels.Font.Color = Colors.Red;
            }
        }
        void Window23_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);
            TimeSpan time = ViewStartTime.Subtract(TrendWidgetStartTime);
            tChart1.Axes.Bottom.SetMinMax(ViewStartTime.ToOADate(), ViewStartTime.AddMinutes(totalMins).ToOADate());
        }

        void IntializeChart()
        {
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 0, 1);
            timer.Tick += timer_Tick;
            timer.Start();
            Random Rnd = new Random();
            tChart1.Aspect.View3D = false;
            tChart1.Zoom.Allow = false;
            tChart1.Series.Add(line);
            line.Tag = "Temp";
            line.XValues.DateTime = true;
            line.Color = Colors.Red;
            line.TreatNulls = TreatNullsStyle.DoNotPaint;
            //line.IgnoreNulls = false;
            line.LinePen.Width = 3;
            line.SetNull(0);
            line.XValues.DataMember = "DateTime";
            line.YValues.DataMember = "Value";

            int POINTS_COUNT = (int)HISTORYREADHOURS * 60;
            Random rnd = new Random();
            for (int i = POINTS_COUNT; i >= 0; i--)
            {
                if (data == 50) data = 70;
                else data = 50;
                data = rnd.Next(20, 50);
                Points.Add(new TrendData(DateTime.Now.AddSeconds(-(i * 1)), data));
            }
            line.DataSource = Points;
            DateTime dt = DateTime.Now.AddMinutes(-20);

            tChart1.Axes.Bottom.Minimum = dt.ToOADate();
            tChart1.Axes.Bottom.Maximum = DateTime.Now.AddHours(1).ToOADate();
            tChart1.Axes.Bottom.Minimum = new DateTime(2013, 01, 01, 00, 00, 00).ToOADate();
            tChart1.Axes.Bottom.Maximum = new DateTime(2013, 01, 02, 00, 00, 00).ToOADate();
            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-30), DateTime.Now.AddMinutes(15));
            tChart1.Axes.Bottom.Increment = Steema.TeeChart.WPF.Utils.GetDateTimeStep(Steema.TeeChart.WPF.DateTimeSteps.FiveMinutes);
            tChart1.Axes.Bottom.AutomaticMaximum = false;
            tChart1.Axes.Left.SetMinMax(0, 200);
            tChart1.Axes.Bottom.StartPosition = 0;
            tChart1.Axes.Left.AxisPen.Width = 5;
            tChart1.Axes.Bottom.AxisPen.Width = 1;
            tChart1.Axes.Left.OtherSide = true;
            tChart1.Axes.Left.MinorTicks.Visible = false;
            tChart1.Axes.Bottom.MinorTicks.Visible = false;
            tChart1.Axes.Left.Ticks.Visible = false;
            tChart1.Axes.Bottom.Ticks.Visible = false;
            tChart1.Axes.Bottom.Ticks.Visible = true;
            tChart1.Axes.Bottom.Ticks.Color = Colors.Transparent;
            tChart1.Axes.Bottom.Ticks.Length = 5;
            tChart1.Axes.Left.Ticks.Visible = false;
            tChart1.Axes.Bottom.Grid.Visible = true;
            tChart1.Axes.Bottom.Grid.Style = DashStyles.Solid;
            tChart1.Axes.Left.Grid.Style = DashStyles.Solid;
            tChart1.Axes.Bottom.Labels.Style = AxisLabelStyle.Value;
            tChart1.Axes.Bottom.Labels.Width = 100;
            tChart1.Axes.Left.Automatic = false;
            tChart1.Axes.Left.Minimum = 10.00;
            tChart1.Axes.Left.Maximum = 100.00;

            tChart1.Header.Visible = false;
            tChart1.Legend.Visible = false;
            tChart1.Aspect.View3D = false;

            tChart1.Walls.Back.Visible = true;
            tChart1.Walls.Back.Color = (Color)ColorConverter.ConvertFromString("#FFF0F0F0");
            tChart1.Walls.Back.Gradient.Visible = false;
            tChart1.Walls.Back.Pen.Width = 1;
            tChart1.Walls.Back.Pen.Color = Colors.Black;

            tChart1.Panel.Gradient.Visible = false;
            tChart1.Panel.Color = Colors.Transparent;
            tChart1.Panel.Gradient.StartColor = Colors.LightGray;
            tChart1.Panel.Gradient.EndColor = Colors.LightGray;
            tChart1.Panel.Bevel.Outer = BevelStyles.None;
            tChart1.Panel.Bevel.Inner = BevelStyles.None;
            tChart1.Panel.MarginBottom = 0;
            tChart1.Panel.MarginLeft = 0;
            tChart1.Panel.MarginRight = 0;
            tChart1.Panel.MarginTop = 0;
            tChart1.Panel.BevelInner = Steema.TeeChart.WPF.Drawing.BevelStyles.None;
            tChart1.Panel.BevelOuter = Steema.TeeChart.WPF.Drawing.BevelStyles.None;

            currentCursorTool = new CursorTool();
            currentCursorTool.Active = true;
            currentCursorTool.Style = CursorToolStyles.Vertical;
            currentCursorTool.Pen.Style = DashStyles.Solid;
            currentCursorTool.Pen.Width = 2;
            currentCursorTool.Pen.Color = System.Windows.Media.Brushes.RoyalBlue.Color;
            currentCursorTool.Active = true;
            tChart1.Tools.Add(currentCursorTool);

            pastCursorTool = new CursorTool();
            pastCursorTool.FollowMouse = false;
            pastCursorTool.Active = true;
            pastCursorTool.Style = CursorToolStyles.Vertical;
            pastCursorTool.Pen.Style = DashStyles.Solid;
            pastCursorTool.Pen.DrawingPen.StartLineCap = PenLineCap.Round;
            pastCursorTool.Pen.Width = 2;
            pastCursorTool.Pen.Color = System.Windows.Media.Brushes.Red.Color;
            tChart1.Tools.Add(pastCursorTool);

        }

        void timer_Tick(object sender, EventArgs e)
        {
            TrendWidgetStartTime=TrendWidgetStartTime.AddSeconds(1);
            TrendWidgetEndTime = TrendWidgetEndTime.AddSeconds(1);

            TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);
            ViewStartTime = DateTime.Now;
            Random rnd = new Random();
            int n = rnd.Next(20, 80);
            line.Add(DateTime.Now, data, "");

            //if (data == 70) data = 50;
            //else data = 70;
            data = n;

            txtBlock.Text = DateTime.Now.ToString() + ":" + n;
            pastCursorTool.XValue = DateTime.Now.ToOADate();
            currentCursorTool.XValue = DateTime.Now.ToOADate();
            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
        }

        private void IntializeScroll()
        {
            pastCursorTool.XValue = DateTime.Now.ToOADate();
            currentCursorTool.XValue = DateTime.Now.ToOADate();
            TrendWidgetStartTime = DateTime.Now.AddMinutes(-ScrollYearMins);
            TrendWidgetEndTime = DateTime.Now.AddMinutes(((totalMins / 4)));
            ViewStartTime = DateTime.Now.AddMinutes(-((totalMins / 4) * 3));
            ViewEndTime = DateTime.Now.AddMinutes(((totalMins / 4)));
            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
        }

    }
}
